VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "RiempiConImmagine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*********************************************************************
'Titolo: RiempiConImmagine
'Autore: Giorgio Bernardi
'E-Mail: BGSoftware@hotmail.com
'Data  : Aprile 2001
'Descrizione: Classe per riempire un Form con una immagine, replicandola
'             quanto basta per ricoprirlo
'Info:  Potete usare e modificare a piacimento questo codice
'       L'immagine pu essere indicata o tramite percorso di un
'       file su disco, oppure come un oggetto. (Vedi Esempio)
'       IMPORTANTE! La propriet del Form AutoRedraw viene impostata
'       su False, altrimenti non viene generato l'evento Paint!
'       Ricordate che l'oggetto creato
'*********************************************************************

Option Explicit

Private WithEvents MyForm As Form
Attribute MyForm.VB_VarHelpID = -1
Private MyPicture As StdPicture
Private IsPicture As Boolean

'Api Necessarie
Private Declare Function BitBlt Lib "Gdi32.dll" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function CreateCompatibleDC Lib "Gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "Gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "Gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long

Public Property Set FormToDraw(YourForm As Form)
     Set MyForm = YourForm
     'IMPORTANTE! Altrimenti non viene generato l'evento Paint!
     MyForm.AutoRedraw = False
End Property

Property Set PictureToDraw(YourPic As StdPicture)
    Set MyPicture = YourPic
    IsPicture = True
End Property

Public Sub SetPicture(YourPath As String)
    Set MyPicture = LoadPicture(YourPath)
    If MyPicture <> 0 Then IsPicture = True
End Sub

Private Sub PaintIt()
    Dim hTileDC As Long
    Dim X As Integer, Y As Integer                  'In Pixels
    Dim FormWidth As Integer, FormHeight As Integer 'In Pixels
    Dim PWidth As Single, PHeight As Single
    
    'Acquisisco le dimensioni dell'immagine. L'oggetto StdPicture
    'ha le dimensioni sepre definite in HiMetric
    'Mi servono le dimensioni in Pixel perch la funzione BitBlt lavora
    'con tali coordinate!
    PWidth = MyForm.ScaleX(MyPicture.Width, vbHimetric, vbPixels)
    PHeight = MyForm.ScaleY(MyPicture.Height, vbHimetric, vbPixels)
    'Controllo che l'oggetto non abbia altezza o larghezza 0!
    If Not (PWidth > 0 And PHeight > 0) Then Exit Sub
    
    'Creo il documento con il quale riempire la finestra
    'e dico alla finestra che deve utilizzarlo
    hTileDC = CreateCompatibleDC(MyForm.hdc)
    Call SelectObject(hTileDC, MyPicture.Handle)
    'Determino le dimensioni della finestra in Pixels
    FormWidth = MyForm.ScaleX(MyForm.ScaleWidth, MyForm.ScaleMode, vbPixels)
    FormHeight = MyForm.ScaleY(MyForm.ScaleHeight, MyForm.ScaleMode, vbPixels)
    'Disegno: viene utilizzato l'oggetto precedentemente indicato
    For Y = 0 To FormHeight Step PHeight
        For X = 0 To FormWidth Step PWidth
            Call BitBlt(MyForm.hdc, X, Y, PWidth, PHeight, hTileDC, 0, 0, vbSrcCopy)
        Next X
    Next Y
    
    'Se la finestra aveva una Picture, devo rifarla comparire
    If MyForm.Picture <> 0 Then Call MyForm.PaintPicture(MyForm.Picture, 0, 0)

    'Distruggo l'oggetto creato
    Call DeleteDC(hTileDC)
End Sub


'Intercetto l'evento Paint del form
Private Sub MyForm_Paint()
    'Disegna lo sfondo.
    If Not IsPicture Then Exit Sub
    Call PaintIt
End Sub
